#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK84x0x84TN2x1x8_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=84, NB=0, KB=84, 
 * lda=84, ldb=84, ldc=0, mu=2, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.9.35)
 */
{
   #define Nb N
   const float *stM = A + 7056;
   const float *stN = B + (84*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*1)/(84*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 88, incAn = -7056;
   #define incBk 8
   const int incBm = -80, incBn = 84;
   #define incCm 4
   const int incCn = (((ldc) << 1)) - 168;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0;
   register float rC0_0, rC1_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = rC1_0 = 0.0;
         for (k=0; k < 10; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[84];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[85];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[86];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[87];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[88];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[89];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[90];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[91];
            rC0_0 += rA0 * rB0;
            rC1_0 += rA1 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[84];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[85];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[86];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[87];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK84x0x84TN84x84x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=84, NB=0, KB=84, 
 * lda=84, ldb=84, ldc=0, mu=2, nu=5, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.9.35)
 */
{
   const int Nb = (N/5)*5;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 7056;
   const float *stN = B + (84*(Nb));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*2*5)/(84*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 88, incAn = -7056;
   #define incBk 8
   const int incBm = -80, incBn = 420;
   #define incCm 4
   const int incCn = (((ldc) << 3)+((ldc) << 1)) - 168;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1, rB2, rB3, rB4;
   register float rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3, rC0_4, rC1_4;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rC0_0 = rC1_0 = rC0_1 = rC1_1 = rC0_2 = rC1_2 = rC0_3 = rC1_3 = rC0_4 = rC1_4 = 0.0;
            for (k=0; k < 10; k++) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[84];
               rB1 = pB0[84];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[168];
               rB3 = pB0[252];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[336];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[85];
               rB1 = pB0[85];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[169];
               rB3 = pB0[253];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[337];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[86];
               rB1 = pB0[86];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[170];
               rB3 = pB0[254];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[338];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[87];
               rB1 = pB0[87];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[171];
               rB3 = pB0[255];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[339];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[88];
               rB1 = pB0[88];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[172];
               rB3 = pB0[256];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[340];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[89];
               rB1 = pB0[89];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[173];
               rB3 = pB0[257];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[341];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[90];
               rB1 = pB0[90];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[174];
               rB3 = pB0[258];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[342];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[91];
               rB1 = pB0[91];
               rC0_0 += rA0 * rB0;
               rB2 = pB0[175];
               rB3 = pB0[259];
               rC1_0 += rA1 * rB0;
               rB4 = pB0[343];
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC0_3 += rA0 * rB3;
               rC1_3 += rA1 * rB3;
               rC0_4 += rA0 * rB4;
               rC1_4 += rA1 * rB4;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[84];
            rB1 = pB0[84];
            rC0_0 += rA0 * rB0;
            rB2 = pB0[168];
            rB3 = pB0[252];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[336];
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[85];
            rB1 = pB0[85];
            rC0_0 += rA0 * rB0;
            rB2 = pB0[169];
            rB3 = pB0[253];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[337];
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[86];
            rB1 = pB0[86];
            rC0_0 += rA0 * rB0;
            rB2 = pB0[170];
            rB3 = pB0[254];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[338];
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[87];
            rB1 = pB0[87];
            rC0_0 += rA0 * rB0;
            rB2 = pB0[171];
            rB3 = pB0[255];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[339];
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            *pC3 = rC0_3;
            pC3[2] = rC1_3;
            *pC4 = rC0_4;
            pC4[2] = rC1_4;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK84x0x84TN2x1x8_a1_b0(84, k, 84, alpha, ca, lda, cb + (84*(Nb)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_cpNBmm_b0 ATL_cgpNBmm_b0
#endif

void ATL_cJIK84x0x84TN84x84x0_a1_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK84x0x84TN84x84x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK84x0x84TN84x84x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpNBmm_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK84x0x84TN84x84x0_a1_b0(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK84x0x84TN84x84x0_a1_b0(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK84x0x84TN84x84x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK84x0x84TN84x84x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
